<template>
  <main class="BusinessCases">
    <SearchOrCreate
      label-property="name"
      resource-type="machine"
      :loading="loading"
      :resources="businessCases"
      :total-records="totalRecords"
      @search="filter"
    >
      <template #resource="{ resource }">
        <li class="BusinessCases__Item">
          <router-link
            class="BusinessCases__ItemName"
            :to="{ ...ROUTES.RESOURCE, params: { uuid: resource.id } }"
          >
            <Highlightable
              v-if="resource.name"
              :content="resource.name"
              :highlight="queryParams.name"
            />
            <span v-else>{{ t('resource.untitled') }}</span>
          </router-link>

          <Highlightable
            v-if="resource.code"
            class="BusinessCases__ItemCode"
            :content="`#${resource.code}`"
            :highlight="queryParams.code"
          />
          <span v-if="resource.dueDate" class="BusinessCases__ItemDueDate"
            >{{ resource.dueDate ? moment(resource.dueDate).format('LL') : '' }}
            <i class="mdi mdi-calendar"></i>
          </span>
          <span class="BusinessCases__ItemTasks">{{
            resource.tasks.length
          }}</span>
        </li>
      </template>

      <template #toolbar-start>
        <IconSelectButton
          v-model="queryParams.status"
          class="BusinessCases__StatusFilter"
          :options="statusOptions"
        />

        <PButton
          class="BusinessCases__DateSort p-button-outlined p-button-text"
          :icon="`mdi mdi-sort-${
            queryParams['order[dueDate]'] === 'DESC'
              ? 'descending'
              : 'ascending'
          }`"
          :title="
            t(`page.business_cases.order.${queryParams['order[dueDate]']}`)
          "
          @click="toggleSortDate"
        />
      </template>

      <template #toolbar-end>
        <PButton
          :label="t('resource.business_case.create')"
          icon="pi pi-plus"
          class="p-button-success p-mr-2"
          @click="showDialog = true"
        />
      </template>
    </SearchOrCreate>

    <BusinessCaseDialog
      v-model:visible="showDialog"
      @resource:created="openBusinessCase"
    />
  </main>
</template>
<script lang="ts" setup>
import { useI18n } from 'vue-i18n'
import { onMounted, reactive, ref, toRaw, watch } from 'vue'
import { useRouter } from 'vue-router'
import { BusinessCaseDialog } from '@/components/resources'
import { ROUTES } from '@/plugins'
import {
  BusinessCase,
  businessCaseClient,
  BusinessCasesParams,
  ResourceType,
} from '@/api/resources'
import moment from 'moment-timezone'
import { Highlightable } from '@/components/Highlightable'
import { RESOURCE_ICONS } from '@/components/resources'
import IconSelectButton from '@/components/form/IconSelectButton.vue'

const router = useRouter()
const { t } = useI18n()
const businessCases = ref<BusinessCase[]>([])
const name = ref('')
const totalRecords = ref(0)
const loading = ref<boolean>(false)

const showDialog = ref<boolean>(false)

const queryParams = reactive<BusinessCasesParams>({
  page: 1,
  'order[dueDate]': 'ASC',
  status: 'open',
  code: undefined,
})

const statusOptions = [
  {
    name: 'resource.business_case.opened',
    value: 'open',
    icon: RESOURCE_ICONS[ResourceType.BusinessCase],
  },
  {
    name: 'resource.business_case.archived',
    value: 'archived',
    icon: 'mdi mdi-archive-outline',
  },
]

function toggleSortDate() {
  queryParams['order[dueDate]'] =
    queryParams['order[dueDate]'] === 'DESC' ? 'ASC' : 'DESC'
}

/**
 * Load data from API & update data-table
 */
async function loadData() {
  loading.value = true
  try {
    let result = await businessCaseClient.getCollection(toRaw(queryParams))
    businessCases.value = result.resources
    totalRecords.value = result.total
  } finally {
    loading.value = false
  }
}

function openBusinessCase(businessCase: BusinessCase) {
  router.push({ ...ROUTES.RESOURCE, params: { uuid: businessCase.id } })
}

const TERM_REGEX = /#(?<code>\S+)/

function filter(search: { page: number; name: string }) {
  queryParams.page = search.page

  const groups = search.name.match(TERM_REGEX)?.groups
  if (groups) {
    queryParams.name = ''
    queryParams.code = groups.code.trim()
  } else {
    queryParams.name = search.name.trim()
    queryParams.code = undefined
  }
}

onMounted(loadData)
watch(queryParams, loadData)
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;

.BusinessCases {
  position: relative;
  padding: v.$spacing;

  &__Item {
    display: grid;
    grid-template-areas:
      'name          tasks'
      'code dueDate';
    grid-template-rows: 1fr minmax(min-content, auto);
    grid-template-columns: 1fr minmax(min-content, auto);
    gap: v.$spacing-2;
    align-items: center;
    padding: v.$spacing;
    border-top: solid 1px var(--surface-50);

    &:first-child {
      border-top: none;
    }

    &Name {
      flex: 1 1;
      grid-area: name;
      color: var(--text-color);
      font-weight: 500;
      text-decoration: none;

      &:hover {
        text-decoration: underline;
      }
    }

    &Code {
      grid-area: code;
      color: var(--text-color-secondary);
      font-style: italic;
      font-size: 0.9rem;
    }

    &Tasks {
      grid-area: tasks;
      justify-self: end;
    }

    &DueDate {
      grid-area: dueDate;
      justify-self: end;
      color: var(--text-color-secondary);
      font-size: 0.9rem;
    }
  }

  &__StatusFilter {
    margin-left: v.$spacing;
  }

  &__DateSort.p-button {
    margin-left: v.$spacing;
    padding: v.$spacing-2 v.$spacing;
  }
}
</style>
